#include "main.h"
    
void rotateGravityBySpin() {
    float xGravity, yGravity, zGravity, tempx, tempy, tempz;
    double rxspin,ryspin,rzspin;


    xGravity = defaultgravity[0];
    yGravity = defaultgravity[1];
    zGravity = defaultgravity[2];

    
    rxspin = -((double)xspin) * M_PI / 180.0;
    ryspin = -((double)yspin) * M_PI / 180.0;
    rzspin = -((double)zspin) * M_PI / 180.0;

    tempy = (float)(((double)yGravity)*cos(rxspin) - ((double)zGravity)*sin(rxspin));
    zGravity = (float)(((double)yGravity)*sin(rxspin) + ((double)zGravity)*cos(rxspin));
    yGravity = tempy;
    
    tempz = (float)(((double) zGravity)*cos(ryspin) - ((double)xGravity)*sin(ryspin));
    xGravity = (float)(((double) zGravity)*sin(ryspin) + ((double)xGravity)*cos(ryspin));
    zGravity = tempz;
    
    tempx = (float)(((double) xGravity)*cos(rzspin) - ((double)yGravity)*sin(rzspin));
    yGravity = (float)(((double) xGravity)*sin(rzspin) + ((double)yGravity)*cos(rzspin));
    xGravity = tempx;
    pEngine->setGravity(xGravity, yGravity, zGravity);

    return;
}


void init() {

    xspin = yspin = zspin = 0;
    dist = 10.0;


    glClearColor(0.0, 0.0, 0.0, 0.0);
    glShadeModel(GL_SMOOTH);
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);


    // ORIGINAL LIGHTING 
    //
    // 

    /*
    GLfloat light_position[] = {0.0, 0.0, 0.0, 1.0};
    GLfloat white_light[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat lmodel_ambient[]= {0.1, 0.1, 0.1, 1.0};

    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);

    glLightfv(GL_LIGHT0, GL_POSITION, light_position);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, white_light);
    glLightfv(GL_LIGHT0, GL_SPECULAR, white_light);
    
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);

    */

    // ALTERNATIVE LIGHTING WITH TWO SPOTLIGHTS
    //
    //

   
    GLfloat light_ambient[] = {0.2, 0.2, 0.2, 1.0};
    GLfloat light_diffuse[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat light_specular[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat light0_position[] = {2.0, 2.0, 0.0, 1.0};
    GLfloat light1_position[] = {-2.0, -2.0, 0.0, 1.0};
    GLfloat spot0_direction[] = {-1.5, -1.5, -1.0};
    GLfloat spot1_direction[] = {1.5, 1.5, -1.0};

    glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
    glLightfv(GL_LIGHT0, GL_POSITION, light0_position);
    glLightf(GL_LIGHT0, GL_CONSTANT_ATTENUATION, 1.0);
    glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 0.0);
    glLightf(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0.0);
    glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 90.0);
    glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, 1.0);
    glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, spot0_direction);
    glLightfv(GL_LIGHT1, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT1, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT1, GL_SPECULAR, light_specular);
    glLightfv(GL_LIGHT1, GL_POSITION, light1_position);
    glLightf(GL_LIGHT1, GL_CONSTANT_ATTENUATION, 1.0);
    glLightf(GL_LIGHT1, GL_LINEAR_ATTENUATION, 0.0);
    glLightf(GL_LIGHT1, GL_QUADRATIC_ATTENUATION, 0.0);
    glLightf(GL_LIGHT1, GL_SPOT_CUTOFF, 90.0);
    glLightf(GL_LIGHT1, GL_SPOT_EXPONENT, 1.0);
    glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, spot1_direction);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHT1);

   


    
    glEnable(GL_DEPTH_TEST);


    pEngine->init();
    

}

void display() {

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glPushMatrix();
    glRotated((GLdouble)xspin, 1.0, 0.0, 0.0);
    glRotated((GLdouble)yspin, 0.0, 1.0, 0.0);
    glRotated((GLdouble)zspin, 0.0, 0.0, 1.0);
    ball[0]->draw();
    ball[1]->draw();
    cube->draw();
    glPopMatrix();
    glFlush();
    glutSwapBuffers();

}


void reshape(int w, int h) {
    
    glViewport(0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(65.0, (GLfloat)w / (GLfloat)h, 1.0, 30.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluLookAt(0.0, 0.0, dist, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
}


void keyboard(unsigned char key, int x, int y) {

    switch (key) {
	case 'f':
	    if (dist < 20.0) {
		dist = dist + 1.0;
    		glLoadIdentity();
    		gluLookAt(0.0, 0.0, dist, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
		glutPostRedisplay();
	    }
	    break;
	case 'n':
	    if (dist > 2.0) {
		dist = dist - 1.0;
		glLoadIdentity();
    		gluLookAt(0.0, 0.0, dist, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
		glutPostRedisplay();
	    }
	    break;
	case 'r':
	    dist = 10.0;
	    xspin = 0;
	    yspin = 0;
	    zspin = 0;
	    pEngine->setGravity(defaultgravity[0], defaultgravity[1], defaultgravity[2]);
	    glLoadIdentity();
	    gluLookAt(0.0, 0.0, dist, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
	    glutPostRedisplay();
	    break;
	case 'q':
	    exit(0);
	case 'p':
	    pEngine->toggle();
	    break;
	default:
	    break;
    }		
}


void keyboards(int key, int x, int y) {

    switch (key) {
	case GLUT_KEY_LEFT:
		xspin = (xspin + 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    break;
	case GLUT_KEY_RIGHT:
		xspin = (xspin - 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    break;
	case GLUT_KEY_UP:
		yspin = (yspin + 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    break;
	case GLUT_KEY_DOWN:
		yspin = (yspin - 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    break;
	case GLUT_KEY_PAGE_UP:
		zspin = (zspin + 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    break;
	case GLUT_KEY_PAGE_DOWN:
		zspin = (zspin - 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    break;
	default:
	    break;
    }		

}



void mouse(int button, int state, int x, int y) {
    
    switch (button) {
	case GLUT_LEFT_BUTTON:
	    if (state == GLUT_DOWN) {
		xspin = (xspin + 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    }
	    break;
	case GLUT_MIDDLE_BUTTON:
	    if (state == GLUT_DOWN) {
		yspin = (yspin + 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    }
	    break;
	case GLUT_RIGHT_BUTTON:
	    if (state == GLUT_DOWN) {
		zspin = (zspin + 15) % 360;
		rotateGravityBySpin();
		glutPostRedisplay();
	    }
	    break;
	default:
	    break;
    }

}


void idle() {
    pEngine->step();
    glutPostRedisplay();
}




int main(int argc, char** argv) {

    GLMmodel *model;
    GLuint numvertices;
    GLfloat* vertices;
    GLuint numtriangles;
    GLMtriangle* triangles;
    
    float (*meshpoints)[3];
    int (*meshtriangles)[3];
    

 

    
    if (argc < 2) {
	std::cout << "usage: main model-file.obj\nexiting...\n";
	return 1;
    }

    std::cout << "commands:" << std::endl;
    std::cout << "   p = start physics" << std::endl;
    std::cout << "   n = zoom in" << std::endl;
    std::cout << "   f = zoom out" << std::endl;
    std::cout << "   q = quit" << std::endl;
    std::cout << "   use arrow keys and PgUp/PgDn to rotate" << std::endl;

    GLfloat scalefactor;
    model = glmReadOBJ(argv[1]);
    scalefactor = glmUnitize(model);
    numvertices = model->numvertices;
    vertices = model->vertices;
    numtriangles = model->numtriangles;
    triangles = model->triangles;

    meshpoints = new float[numvertices][3];
    meshtriangles = new int[numtriangles][3];
    
    for(GLuint i=1; i <= numvertices; ++i) {
	meshpoints[i-1][0] = (float)vertices[3 * i + 0];
	meshpoints[i-1][1] = (float)vertices[3 * i + 1];
	meshpoints[i-1][2] = (float)vertices[3 * i + 2];
    }
	

    for(GLuint i=0; i < numtriangles; ++i) {
	meshtriangles[i][0] = (int)triangles[i].vindices[0] - 1;
	meshtriangles[i][1] = (int)triangles[i].vindices[1] - 1;
	meshtriangles[i][2] = (int)triangles[i].vindices[2] - 1;
    }

  
    


  

    glutInit(&argc, argv);

    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize(800, 600);
    glutInitWindowPosition(0,0);
    glutCreateWindow(argv[0]);

    cube = new Cube(0.0, 0.0, 0.0, 5.0);
//    std::cout << "creating ball 0" << std::endl;
    ball[0] = new Ball(0.0, -1.0, 0.0, 0.5, 0.0, 0.0, (int)numvertices, meshpoints, (int)numtriangles, meshtriangles);
    pEngine = new PhysicsEngine(cube, ball[0]);
//    std::cout << "creating ball 1" << std::endl;
    ball[1] = new Ball(0.0, 1.0, 0.0, -0.3, 0.0, 0.0, (int)numvertices, meshpoints, (int)numtriangles, meshtriangles);
    pEngine->addBall(ball[1]);
    delete[] meshpoints;
    delete[] meshtriangles;
    pEngine->setGravity(defaultgravity[0], defaultgravity[1], defaultgravity[2]);
    init();
    glutDisplayFunc(display);
    glutReshapeFunc(reshape);
    glutKeyboardFunc(keyboard);
    glutSpecialFunc(keyboards);
    glutMouseFunc(mouse);
    glutIdleFunc(idle);
    glutMainLoop();
    
    return (0);


}

