#ifndef _PHYSICSENGINE_H_
#define _PHYSICSENGINE_H_

#include "cube.h"
#include "ball.h"


class PhysicsEngine {
    
    private:
	float gravity_[3];
	long long int time;
	Cube* cube_;
	Ball* ball_[5];  // maximal 5 balls are allowed
	int numberOfBalls;
	bool isRunning_;

    protected:
	
    public:
	PhysicsEngine(Cube* cube,Ball* ball);
	~PhysicsEngine();
	void addBall(Ball *neuball);
	void init();
	void start();
	void stop();
	void toggle();
	void step();
	void setGravity(float gravityX, float gravityY, float gravityZ);

};

#endif 
